# Class TableWrapLayout

java.lang.Object
org.eclipse.swt.widgets.Layout
org.eclipse.ui.forms.widgets.TableWrapLayout

All Implemented Interfaces:
  `ILayoutExtension`

public final class TableWrapLayout extends Layout implements ILayoutExtension
This implementation of the layout algorithm attempts to position controls in the composite using a two-pass autolayout HTML table algorithm recommended by HTML 4.01 W3C specification (see http://www.w3.org/TR/html4/appendix/notes.html#h-B.5.2.2). The main differences with GridLayout is that it has two passes and that width and height are not calculated in the same pass.

The advantage of the algorithm over GridLayout is that it is capable of flowing text controls capable of line wrap. These controls do not have natural 'preferred size'. Instead, they are capable of providing the required height if the width is set. Consequently, this algorithm first calculates the widths that will be assigned to columns, and then passes those widths to the controls to calculate the height. When a composite with this layout is a child of the scrolling composite, they should interact in such a way that reduction in the scrolling composite width results in the reflow and increase of the overall height.

If none of the columns contain expandable and wrappable controls, the end-result will be similar to the one provided by GridLayout. The difference will show up for layouts that contain controls whose minimum and maximum widths are not the same.

Since:
  3.0
See Also:
  - `TableWrapData`

## Field Summary

Fields
Modifier and Type
Field
Description
`int`
`bottomMargin`
Botom margin variable (default is 5).
`int`
`horizontalSpacing`
Horizontal spacing (default is 5).
`int`
`leftMargin`
Left margin variable (default is 5).
`boolean`
`makeColumnsEqualWidth`
If set to `true`, all the columns will have the same width.
`int`
`numColumns`
Number of columns to use when positioning children (default is 1).
`int`
`rightMargin`
Right margin variable (default is 5).
`int`
`topMargin`
Top margin variable (default is 5).
`int`
`verticalSpacing`
Vertical spacing (default is 5).

## Constructor Summary

Constructors
Constructor
Description
`TableWrapLayout()`

## Method Summary

Modifier and Type
Method
Description
`int`
`computeMaximumWidth(Composite parent, boolean changed)`
Implements ILayoutExtension.
`int`
`computeMinimumWidth(Composite parent, boolean changed)`
Implements ILayoutExtension.
`protected Point`
`computeSize(Composite parent, int wHint, int hHint, boolean changed)`
Computes and returns the size of the specified composite's client area according to this layout.
`protected void`
`layout(Composite parent, boolean changed)`
Lays out the children of the specified composite according to this layout.

### Methods inherited from class Layout

`flushCache`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### numColumns

public int numColumns
Number of columns to use when positioning children (default is 1).

### leftMargin

public int leftMargin
Left margin variable (default is 5).

### rightMargin

public int rightMargin
Right margin variable (default is 5).

### topMargin

public int topMargin
Top margin variable (default is 5).

### bottomMargin

public int bottomMargin
Botom margin variable (default is 5).

### horizontalSpacing

public int horizontalSpacing
Horizontal spacing (default is 5).

### verticalSpacing

public int verticalSpacing
Vertical spacing (default is 5).

### makeColumnsEqualWidth

public boolean makeColumnsEqualWidth
If set to `true`, all the columns will have the same width. Otherwise, column widths will be computed based on controls in them and their layout data (default is `false`).

## Constructor Details

### TableWrapLayout

public TableWrapLayout()

## Method Details

### computeMinimumWidth

public int computeMinimumWidth(Composite parent, boolean changed)
Implements ILayoutExtension. Should not be called directly.

Specified by:
  `computeMinimumWidth` in interface `ILayoutExtension`
Parameters:
  `parent` - the parent composite
  `changed` - `true` if the cached information should be flushed, `false` otherwise.
Returns:
  the minimum width of the parent composite
See Also:
  - `ILayoutExtension`

### computeMaximumWidth

public int computeMaximumWidth(Composite parent, boolean changed)
Implements ILayoutExtension. Should not be called directly.

Specified by:
  `computeMaximumWidth` in interface `ILayoutExtension`
Parameters:
  `parent` - the parent composite
  `changed` - `true` if the cached information should be flushed, `false` otherwise.
Returns:
  the maximum width of the parent composite
See Also:
  - `ILayoutExtension`

### layout

protected void layout(Composite parent, boolean changed)
Description copied from class: `Layout`
Lays out the children of the specified composite according to this layout.

This method positions and sizes the children of a composite using the layout algorithm encoded by this layout. Children of the composite are positioned in the client area of the composite. The position of the composite is not altered by this method.

When the flush cache hint is true, the layout is instructed to flush any cached values associated with the children. Typically, a layout will cache the preferred sizes of the children to avoid the expense of computing these values each time the widget is laid out.

When layout is triggered explicitly by the programmer the flush cache hint is true. When layout is triggered by a resize, either caused by the programmer or by the user, the hint is false.

Specified by:
  `layout` in class `Layout`
Parameters:
  `parent` - a composite widget using this layout
  `changed` - `true` means flush cached layout values
See Also:
  - `Layout.layout(Composite, boolean)`

### computeSize

protected Point computeSize(Composite parent, int wHint, int hHint, boolean changed)
Description copied from class: `Layout`
Computes and returns the size of the specified composite's client area according to this layout.

This method computes the size that the client area of the composite must be in order to position all children at their preferred size inside the composite according to the layout algorithm encoded by this layout.

When a width or height hint is supplied, it is used to constrain the result. For example, if a width hint is provided that is less than the width of the client area, the layout may choose to wrap and increase height, clip, overlap, or otherwise constrain the children.

Specified by:
  `computeSize` in class `Layout`
Parameters:
  `parent` - a composite widget using this layout
  `wHint` - width (`SWT.DEFAULT` for preferred size)
  `hHint` - height (`SWT.DEFAULT` for preferred size)
  `changed` - `true` means flush cached layout values
Returns:
  a point containing the computed size (width, height)
See Also:
  - `Layout.computeSize(Composite, int, int, boolean)`